#/* Lattice Gas-Automat, Praktikumsgruppe P5, SS1995

Hier:
Deklaration der Hauptroutinen und Uebersicht ueber die Struktur.
File I/O
*/
/*#define _TEST_
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "p5-lat.h"

/* Variablendeklaration */
TWord           wZeilen;        /* Anzahl der Matrixzeilen */
TWord           wSpalten;       /* und -spalten */
TWord           wSeed;          /* ZufallszahlenGenerator - Initialisierung (0=time) */
TWord           wBarrieren;     /* Anzahl Barrieren */
TWord           wBildZeile;     /* Zeilennummer der ersten darzustellenden Zelle */
TWord           wBildSpalte;    /* Spaltennummer der ersten darzustellenden Zelle */
TWord           wBildSchritte;  /* Anzahl der Berechnungsschritte zwischen Ausgabe */
TWord           wMaxZeit;       /* maximale Rechenzeit */
TWord           wDichte;        /* Belegungsdichte der Matrix */
TWord           wFluss;         /* Fluss durch die Matrix */
TptrZellFeld    *ptrZellFeldBasis; /* Anfangsadresse der Matrix */
TBListe         *BListeWurzel;  /* Wurzel der Barriereliste */
TBListe         *BListeAktuell; /* Zeiger auf aktuelles Listenelement */

int     readFile(char *IOString);       /* liest die Simulatioswerte ein */
TWord    LiesWordAusDatei(FILE *);       /* liest einen WORD-Wert aus der Datei */
void    TestAusgabe(void);              /* gibt sie testweise aus */
void    liesBarriere(FILE *);             /* liest eine Barriere ein */
TRechteck *erstelleBarriere(void);      /* reserviert Speicher f. Barrieren u. verwaltet diesen */


int     readFile(char *IOString)
{
int     res;
FILE    *fh;

        /* zunaechst Initialisierung von Vars u. Zeigern */
        /* BarriereListe: */
        BListeWurzel = malloc(sizeof(TBListe));
        if(BListeWurzel == NULL)
        {
                fprintf(stderr,"\nFEHLER: zu wenig Speicher ! (Wurzel)");
                fflush(stderr);
                exit(1);
        }
        BListeWurzel->Knoten = malloc(sizeof(TRechteck));
        BListeWurzel->next   = NULL;
        BListeAktuell = BListeWurzel;
        if(BListeWurzel->Knoten == NULL)
        {
                fprintf(stderr,"\nFEHLER: zu wenig Speicher ! (Wurzel->Knoten)");
                fflush(stderr);
                exit(1);
        }       
        res = strcmp("Console",IOString);
        if(res)
        {
            /* FILE - IO */
            fprintf(stderr,"Lese aus Datei: %s",IOString);
            fflush(stderr);
            fh = fopen(IOString,"r");
            if(fh != NULL)
            {
                    wZeilen     = LiesWordAusDatei(fh);
                    wSpalten    = LiesWordAusDatei(fh);
                    wBarrieren  = LiesWordAusDatei(fh);
                    wSeed       = LiesWordAusDatei(fh);
                    wBildZeile  = LiesWordAusDatei(fh);
                    wBildSpalte = LiesWordAusDatei(fh);
                    wBildSchritte = LiesWordAusDatei(fh);
                    wMaxZeit    = LiesWordAusDatei(fh);
                    wDichte     = LiesWordAusDatei(fh);
                    wFluss      = LiesWordAusDatei(fh);
                    for(res=0;res<wBarrieren;res++)
                        liesBarriere(fh);
                    fclose(fh);
            }
            else
            {
                fprintf(stderr,"\nFEHLER !!!!, Datei konnte nicht geoeffnet werden: (%s)",IOString);
                fflush(stderr);
                return(1);
            }
            TestAusgabe();      /* testweise Ausgabe der geliesnen Werte */
        }
        else
        {
            /* Keyboard - IO */
            fprintf(stderr,"Zeilenanzahl  : "); fflush(stderr); fscanf(stdin,"%d",&wZeilen);
            fprintf(stderr,"Spaltenanzahl : "); fflush(stderr); fscanf(stdin,"%d",&wSpalten);
            fprintf(stderr,"Barrierenzahl : "); fflush(stderr); fscanf(stdin,"%d",&wBarrieren);
            fprintf(stderr,"Initwert f. Zufallszahlengenerator : "); fflush(stdin); fscanf(stdin,"%d",&wSeed);
            fprintf(stderr,"1. darzustellende Zeile  : "); fflush(stderr); fscanf(stdin,"%d",&wBildZeile);
            fprintf(stderr,"1. darzustellende Spalte : "); fflush(stderr); fscanf(stdin,"%d",&wBildSpalte);
            fprintf(stderr,"Schrittanzahl zwischen Ausgaben : "); fflush(stderr); fscanf(stdin,"%d",&wBildSchritte);
            fprintf(stderr,"max. Zeitintervall der Berechnung : "); fflush(stderr); fscanf(stdin,"%d",&wMaxZeit);
            fprintf(stderr,"Dichte : "); fflush(stderr); fscanf(stdin,"%d",&wDichte);
            fprintf(stderr,"Fluss  : "); fflush(stderr); fscanf(stdin,"%d",&wFluss);
            for(res=0;res<wBarrieren;res++)
                liesBarriere(NULL);       /* von Console */
        }
        /* Initialisierung der "Hauptbarriere", d.h. des Matrixrandes : */
        BListeWurzel->Knoten->LinksOben.x = 0;               
        BListeWurzel->Knoten->LinksOben.y = 0;               
        BListeWurzel->Knoten->RechtsUnten.x = wSpalten;               
        BListeWurzel->Knoten->RechtsUnten.y = wZeilen;               
        return(0);
}

TWord   LiesWordAusDatei(FILE *fh)
{
TWord   wWert;
int     iWert;

        /* ersten numerischen Wert suchen */
       iWert = fgetc(fh);
       while((iWert != NULL) && ((iWert < 48) || (iWert > 57)))
           iWert = fgetc(fh);
       if(iWert == NULL)
       {
           fprintf(stderr,"FEHLER !!! beim Lesen aus Datei (Unerwartetes Dateiende)");
           fflush(stderr);
           exit(1);             /* nicht sehr elegant, aber wirkungsvoll ! */
       }
       wWert = iWert-48;
       iWert = fgetc(fh);
       while((iWert != NULL) && (iWert > 47) && (iWert < 58))
       {
           wWert *= 10;
           wWert += (iWert-48);
           iWert = fgetc(fh);
       }
       return(wWert);
}

void    TestAusgabe(void)
{
    printf("\nMatrixgroesse :  %d x %d",wZeilen,wSpalten);
    printf("\n%d Barrieren",wBarrieren);
    printf("\nDarstellung beginnt bei (%d,%d)",wBildZeile,wBildSpalte);
    printf("\nZeitparameter: %d (Darstellung) %d (total)",wBildSchritte,wMaxZeit);
    printf("\nZufallsgenerator Initwert: %d",wSeed);
    fflush(stdout);
}

void    liesBarriere(FILE *fh)
{
        TRechteck       *ptrBarriere;
        TWord           runvar;
        int             inputWert;
        
        /* Barriere einlesen, bei fh == NULL von Konsole, sonst aus FILE */
        /* gleichzeitig muss Speicher fuer die Werte reserviert werden (und
        natuerlich auch verwaltet) */
        /* Schleife ueber der Anzahl von Barrieren */
        for(runvar=0;runvar<1/*wBarrieren*/;runvar++)
        {
                /* Zunaechst Speicher bereitstellen: */
                ptrBarriere = erstelleBarriere();
                if(fh == NULL)  /* von Konsole lesen */
                {
                        fprintf(stderr,"\nBarriere Nr. %d",runvar+1);
                        fprintf(stderr,"\nX-Koordinate links oben : ");
                        fflush(stderr);
                        fscanf(stdin,"%d",&inputWert);
                        ptrBarriere->LinksOben.x = inputWert;
                        fprintf(stderr,"Y-Koordinate links oben : ");
                        fflush(stderr);
                        fscanf(stdin,"%d",&inputWert);
                        ptrBarriere->LinksOben.y = inputWert;
                        fprintf(stderr,"X-Koordinate rechts unten : ");
                        fflush(stderr);
                        fscanf(stdin,"%d",&inputWert);
                        ptrBarriere->RechtsUnten.x = inputWert;
                        fprintf(stderr,"Y-Koordinate rechts unten : ");
                        fflush(stderr);
                        fscanf(stdin,"%d",&inputWert);
                        ptrBarriere->RechtsUnten.y = inputWert;
                }
                else
                {               /* aus Datei lesen */
                        /* Reihenfolge: LOX,LOY,RUX,RUY */
                        ptrBarriere->LinksOben.x = LiesWordAusDatei(fh);
                        ptrBarriere->LinksOben.y = LiesWordAusDatei(fh);
                        ptrBarriere->RechtsUnten.x = LiesWordAusDatei(fh);
                        ptrBarriere->RechtsUnten.y = LiesWordAusDatei(fh);
                }
        } /* for wBarrieren */
}

TRechteck       *erstelleBarriere(void)
{
TRechteck       *hptr;
TBListe         *hptr2;

        hptr    = malloc(sizeof(TRechteck));
        hptr2   = malloc(sizeof(TBListe));
        if((hptr == NULL) || (hptr2 == NULL))
        {
                fprintf(stderr,"\nFEHLER !: zuwenig freier Speicher (erstelleBarriere)");
                fflush(stderr);
                exit(1);
        }
        BListeAktuell->next     = hptr2;
        hptr2->next             = NULL;
        hptr2->Knoten           = hptr;
        BListeAktuell           = hptr2;
        return(hptr);
}
