/* Lattice-Gasautomat.

Hier:
Routinen zur Berechnung und Modifikation der Matrix
*/

#define MAINBARRIER__
#define BARRIEREN__
#define CHECKBARRIER__
#define DEBUG__nein

#include <stdio.h>
#include <stdlib.h>
#include "p5-lat.h"

extern TWord	wGrenzwert;
extern TWord	wFlussRechts;
extern TWord	wFlussLinks;
extern TZelle *ptrAufFeldBasis;

extern int localSlaveNumber;
extern int slaveAnzahl;

#define FLIPCOIN (rand()%2)
#define EINSLINKS LinksBewegung(1)
#define ZWEILINKS LinksBewegung(2)
#define EINSRECHTS RechtsBewegung(1)
#define ZWEIRECHTS RechtsBewegung(2)


int		Zeit = 0;
TZelle          *ptrNeueZeile,*ptrAlteZeile,*ptrDieseZeile;
TptrZellFeld	*ptrZellFeldEnde;

int	MainLoop(void);
int	BerechneNeueMatrix(void);
int     BerechneNeueMatrixT800(void);
int	FlussEinbauen(void);
int	testeAbbruchbedingung(void);
int	InitLatCalc(void);
void	ReleaseLatCalc(void);

int	RechtsBewegung(int);
int	LinksBewegung(int);

int	Dichte(TZelle *);
TZelle	simuliereZelle(TZelle *,TWord,TWord);
void	kopiereZeilen(TZelle *);
void	checkBarriers(void);
TZelle	BewegungAnpassen(TZelle);

int	BerechneNeueMatrixT800(void)
{
TWord	runx,runy;
TZelle	Zelle,*ptrZelle,*ptrHZelle;
TZelle *ptrTemp;

#ifdef DEBUG__
if(localSlaveNumber < 20)
{
fprintf(stderr,"Berechnung T800 fuer PN(%d)\n",localSlaveNumber);
fflush(stderr);
}
#endif
        ptrZelle = (TZelle *) ptrZellFeldBasis;
	for(runy=0;runy<wZeilen;runy++)
	{
	        ptrHZelle = (TZelle *) ptrNeueZeile;
		for(runx=0;runx<wSpalten;runx++)
		{
		        Zelle = simuliereZelle(ptrZelle,runx,runy);
			*ptrHZelle = Zelle;
			ptrHZelle++;
			ptrZelle++;
		}
		if(runy > 0)
		  kopiereZeilen(ptrZelle);
		ptrTemp = ptrAlteZeile;
		ptrAlteZeile = ptrNeueZeile;
		ptrNeueZeile = ptrTemp;
	}             
        kopiereZeilen(ptrZelle+wSpalten);
#ifdef BARRIEREN__
        checkBarriers();
#endif
        return(0);
}


int	BerechneNeueMatrix(void)
{
TWord	runx,runy;
TZelle	Zelle,*ptrZelle,*ptrHZelle;
TZelle *ptrTemp;

	ptrZelle	= (TZelle *) ptrZellFeldBasis;
	for(runy=0;runy<wZeilen;runy++)
	{
		ptrHZelle	= (TZelle *) ptrNeueZeile;
		for(runx=0;runx<wSpalten;runx++)
		{
			Zelle = simuliereZelle(ptrZelle,runx,runy);
			*ptrHZelle = Zelle;
			ptrHZelle++;
			ptrZelle++;
		}
		if(runy > 0)
			kopiereZeilen(ptrZelle);
		ptrTemp		= ptrAlteZeile;
		ptrAlteZeile	= ptrNeueZeile;
		ptrNeueZeile	= ptrTemp;
	}
	kopiereZeilen(ptrZelle+wSpalten);
#ifdef BARRIEREN__
        checkBarriers();
#endif
	return(0);
}

int	FlussEinbauen(void)
{
/* TODO */
int runvar;
TRichtung rund;
TZelle *zHptr1,*zHptr2;
TZelle *zH1,*zH2;

	zHptr1 = (TZelle *) ptrZellFeldBasis;
	zHptr2 = zHptr1 + wSpalten - 1;
	zH1 = zHptr1 + 1;
	zH2 = zHptr2 - 1;
	for(runvar=0;runvar<wZeilen;runvar++)
	{
		*zHptr1 = 0;	/* Zellen loeschen */
		*zHptr2 = 0;
		*zH1 = 0;
		*zH2 = 0;
		for(rund=ObenRechts;rund<UntenLinks;rund++)
		{	/* Fluss nach Rechts setzen */
			if(rand() < wFlussRechts)
				*zHptr1	|= (0x01 << rund);
		}
		for(rund=UntenLinks;rund<STOP;rund++)
		{	/* Fluss n. Links setzen */
			if(rand() < wFlussLinks)
				*zHptr2	|= (0x01 << rund);
		}
		for(rund=ObenRechts;rund<UntenLinks;rund++)
		{	/* Fluss nach Rechts setzen */
			if(rand() < wFlussRechts)
				*zH1	|= (0x01 << rund);
		}
		for(rund=UntenLinks;rund<STOP;rund++)
		{	/* Fluss n. Links setzen */
			if(rand() < wFlussLinks)
				*zH2	|= (0x01 << rund);
		}
		zH1    += wSpalten;
		zH2    += wSpalten;
		zHptr1 += wSpalten;
		zHptr2 += wSpalten;
	}
	return(0);
}

int	testeAbbruchbedingung(void)
{	/* 0 = Abbruch */
	Zeit++;
/*TODO: naechste Zeile loeschen*/
/*printf("%d",Zeit);*/
	return(Zeit<wMaxZeit);
}

int	Dichte(TZelle *ptrZelle)
{
TWord	rwert,runvar;

	rwert = 0;
	for(runvar=0;runvar<6;runvar++)
	{
		if(*ptrZelle & (0x01 << runvar))
			rwert++;
	}
	return(rwert);
}
/*
static TptrZellZeile	*PlatzHalter001;	/* intern */
TZelle   *PlatzHalter001;

int	InitLatCalc(void)
{
/* TODO: ...Ende sollte beim einlesen und allokieren berechnet werden */
#ifndef BARRIEREN__
fprintf(stderr,"Barrieren werden nicht berechnet.\n");
fflush(stderr);
#endif
#ifdef DEBUG__
fprintf(stderr,"LATCALC: Initialisierung fuer PN(%d) allokiere (%d)\n",localSlaveNumber,wSpalten+wSpalten);
fflush(stderr);
sleep(2);
#endif
	ptrZellFeldEnde	= ptrZellFeldBasis+(wSpalten*wZeilen);
	PlatzHalter001	= malloc(wSpalten+wSpalten);
        if(PlatzHalter001 == NULL)
	  {
	      fprintf(stderr,"SCHWERER FEHLER !! LATCALC-INIT: malloc(PlatzHalter)\n");
	      fflush(stderr);
	      sleep(10);
	  }
	ptrAlteZeile	= PlatzHalter001;
	ptrNeueZeile	= ptrAlteZeile;
        ptrNeueZeile   += wSpalten;
	if(PlatzHalter001 == NULL)
		return(1);
	return(0);
}

void	ReleaseLatCalc(void)
{
#ifdef DEBUG__
fprintf(stderr,"LATCALC: Release Platzhalter PN(%d)\n",localSlaveNumber);
fflush(stderr);
#endif
	free(PlatzHalter001);
}

TZelle	simuliereZelle(TZelle *ptrCell,TWord x,TWord y)
{
TZelle	res,*ptrOtherCell;
/* TODO: very much
Ich werde die ganze Verschachtelung noch aufloesen, da sie
gar nicht notwendig und ineffektiv ist. */
	res = 0;
	if(((y > 0)||(localSlaveNumber>0))&& (y < (wZeilen-1)))	/* ohne 1. und letzte Zeile */
	{
		if((x > 0) && (x < wSpalten-1))        /* vorerst ohne Raender */
		{
			ptrOtherCell = ptrCell - wSpalten + 1;	/* alles von oben */
			if(*ptrOtherCell & LINKSUNTEN)
				res	|= LINKSUNTEN;
			ptrOtherCell -= 2;
			if(*ptrOtherCell & RECHTSUNTEN)
				res	|= RECHTSUNTEN;
			ptrOtherCell	= ptrCell - 2;		/* von links */
			if(*ptrOtherCell & RECHTS)
				res	|= RECHTS;
			ptrOtherCell   	+= 4;			/* von rechts */
			if(*ptrOtherCell & LINKS)
				res	|= LINKS;
			ptrOtherCell = ptrCell + wSpalten + 1;	/* alles von unten */
			if(*ptrOtherCell & LINKSOBEN)
				res	|= LINKSOBEN;
			ptrOtherCell -= 2;
			if(*ptrOtherCell & RECHTSOBEN)
				res	|= RECHTSOBEN;
			/* OK, so weit so gut, nun noch Kollisionen
			beruecksichtigen */
			if(Dichte(&res)>3)
				res = BewegungAnpassen(res);
			switch(res)
			{
				/* zunaechst 3er (Mercedes-Stil)*/
				case 31:
					res = 62;
					break;
				case 62:
					res = 31;
					break;
				/* 3er (Head-on) */
				case 41:	/* 9er */
					res = 50;
					break;
				case 25:
					res = 52;
					break;
				case 13:
					res = 22;
					break;
				case 11:
					res = 38;
					break;
				case 50:	/* 18er */
					res = 41;
					break;
				case 22:
					res = 13;
					break;
				case 26:
					res = 44;
					break;
				case 19:
					res = 37;
					break;
				case 52:	/* 36er */
					res = 25;
					break;
				case 38:
					res = 11;
					break;
				case 44:
					res = 26;
					break;
				case 37:
					res = 19;
					break;
				/* nun die 2er */
				case 9:
					if(FLIPCOIN)
						res = 18;
					else	res = 36;
					break;
				case 18:
					if(FLIPCOIN)
						res = 9;
					else	res = 36;
					break;
				case 36:
					if(FLIPCOIN)
						res = 9;
					else	res = 18;
					break;
				/* TODO : und nun die 4er */
			}
		      }
	      }
       if(y == (wZeilen-1))
	 {
		if((x > 0) && (x < wSpalten-1))        /* vorerst ohne Raender */
		{
			ptrOtherCell = ptrCell - wSpalten + 1;	/* alles von oben */
			if(*ptrOtherCell & LINKSUNTEN)
				res	|= LINKSUNTEN;
			ptrOtherCell -= 2;
			if(*ptrOtherCell & RECHTSUNTEN)
				res	|= RECHTSUNTEN;
			ptrOtherCell	= ptrCell - 2;		/* von links */
			if(*ptrOtherCell & RECHTS)
				res	|= RECHTS;
			ptrOtherCell   	+= 4;			/* von rechts */
			if(*ptrOtherCell & LINKS)
				res	|= LINKS;
			ptrOtherCell = ptrCell + wSpalten + 1;	/* alles von unten */
			if(*ptrOtherCell & LINKSOBEN)
				res	|= LINKSOBEN;
			ptrOtherCell -= 2;
			if(*ptrOtherCell & RECHTSOBEN)
				res	|= RECHTSOBEN;
			/* OK, so weit so gut, nun noch Kollisionen
			beruecksichtigen */
			if(Dichte(&res)>3)
				res = BewegungAnpassen(res);
			switch(res)
			{
				/* zunaechst 3er (Mercedes-Stil)*/
				case 31:
					res = 62;
					break;
				case 62:
					res = 31;
					break;
				/* 3er (Head-on) */
				case 41:	/* 9er */
					res = 50;
					break;
				case 25:
					res = 52;
					break;
				case 13:
					res = 22;
					break;
				case 11:
					res = 38;
					break;
				case 50:	/* 18er */
					res = 41;
					break;
				case 22:
					res = 13;
					break;
				case 26:
					res = 44;
					break;
				case 19:
					res = 37;
					break;
				case 52:	/* 36er */
					res = 25;
					break;
				case 38:
					res = 11;
					break;
				case 44:
					res = 26;
					break;
				case 37:
					res = 19;
					break;
				/* nun die 2er */
				case 9:
					if(FLIPCOIN)
						res = 18;
					else	res = 36;
					break;
				case 18:
					if(FLIPCOIN)
						res = 9;
					else	res = 36;
					break;
				case 36:
					if(FLIPCOIN)
						res = 9;
					else	res = 18;
					break;
				/* TODO : und nun die 4er */
			}
		      }
	      }
	return(res);
}


void	kopiereZeilen(TZelle *ptrZ)
{
/* Hier wird eine berechnete Zeile in die Zellmatrix kopiert */
/* der uebergebene ZellZeiger steht aber schon zwei Zeilen weiter !*/
TZelle	*ptrH;
TWord	runvar;

	ptrZ	-= (wSpalten + wSpalten);
	ptrH	= (TZelle *) ptrAlteZeile;
	for(runvar=0;runvar<wSpalten;runvar++)
	{
		*ptrZ	= *ptrH;
		ptrZ++;
		ptrH++;
	}
}
 
void	checkBarrier(TWord x1,TWord y1,TWord x2,TWord y2)
{
TZelle	*zHptr1,*zHptr2;
TZelle	*zH1,*zH2;
TWord	LinksOben;
TWord   xd,yd;
int	runvar;

#ifdef DEBUG__
if(localSlaveNumber<17)
  {
      fprintf(stderr,"\n/%d == (%d,%d)x(%d,%d)\n",localSlaveNumber,x1,y1,x2,y2);
      fflush(stderr);
  }
#endif
/*printf("CB (%d/%d)(%d/%d)",x1,y1,x2,y2);
getch();*/
	xd = x2-x1;
	yd = y2-y1;
        if(yd==0) 
	  {
	      yd++;           /* Spezialfall f. Barrierenrand bei SlaveFeldAnfang */
	      y1 = 0;
	  }
	LinksOben = y1*wSpalten+x1;
/*printf("LO %d",LinksOben); getch();*/
	/* OK, nun linken + rechten Rand ueberpruefen */
	zHptr1 = (TZelle *) ptrAufFeldBasis;
	zHptr1 += LinksOben+wSpalten;
	zHptr2 = zHptr1 + xd;
	zH1 = zHptr1 + 1;
	zH2 = zHptr2 - 1;
	for(runvar=0;runvar<yd;runvar++)	/* oberste + unterste Zeile */
	{					/* werden separat behandelt */
		switch(*zHptr1&0x07)
		{
			case 0x07:
				*zHptr1 = 0x38;
				break;
			case 0x05:
			case 0x03:
			case 0x06:
				*zHptr1 = (*zHptr1&0x38) | ZWEILINKS;
				break;
			case 0x01:
			case 0x02:
			case 0x04:
				*zHptr1 = (*zHptr1&0x38) | EINSLINKS;
				break;
			default:
				*zHptr1 = (*zHptr1&0x38);
		}
		switch(*zHptr2&0x38)
		{
			case 0x38:
				*zHptr2 = 0x07;
				break;
			case 0x30:
			case 0x28:
			case 0x18:
				*zHptr2 = (*zHptr2&0x07) | ZWEIRECHTS;
				break;
			case 0x10:
			case 0x20:
			case 0x08:
				*zHptr2 = (*zHptr2&0x07) | EINSRECHTS;
				break;
			default:
				*zHptr2 = *zHptr2&0x07;
		}
		switch(*zH1&0x07)
		{
			case 0x07:
				*zH1 = 0x38;
				break;
			case 0x05:
			case 0x03:
			case 0x06:
				*zH1 = (*zH1&0x38) | ZWEILINKS;
				break;
			case 0x01:
			case 0x02:
			case 0x04:
				*zH1 = (*zH1&0x38) | EINSLINKS;
				break;
			default:
				*zH1 = *zH1 & 0x38;
		}
		switch(*zH2&0x38)
		{
			case 0x38:
				*zH2 = 0x07;
				break;
			case 0x30:
			case 0x28:
			case 0x18:
				*zH2 = (*zH2&0x07) | ZWEIRECHTS;
				break;
			case 0x10:
			case 0x20:
			case 0x08:
				*zH2 = (*zH2&0x07) | EINSRECHTS;
				break;
			default:
				*zH2 = *zH2 & 0x07;
		}


/*TODO: noch nicht korrekt */
	      if(runvar&&(runvar<(yd-1)))
	      {
		zH1++; *zH1 = 0; zH1--;
		zH2--; *zH2 = 0; zH2++;
	      }
		zH1 += wSpalten;
		zH2 += wSpalten;
/**zHptr1 = 0;
*zHptr2 = 0;*/
		zHptr1 += wSpalten;
		zHptr2 += wSpalten;
	}
	/* OK, nun oberer und unterer Rand */
	zHptr1 = (TZelle *) ptrZellFeldBasis;
	zHptr1 += LinksOben;
/*TODO: evtl. +1*/
	zHptr2 = zHptr1 + yd*wSpalten;
        zH1 = zHptr1 + wSpalten;
        zH2 = zHptr2 - wSpalten;
	for(runvar=0;runvar<xd;runvar++)
	{	/* Ecken extra */
		switch(*zHptr1&(LINKSUNTEN|RECHTSUNTEN))
		{
			case LINKSUNTEN:
			case RECHTSUNTEN:
				if(FLIPCOIN)
					*zHptr1 = (*zHptr1&OBEN) | RECHTSOBEN;
				else	*zHptr1 = (*zHptr1&OBEN) | LINKSOBEN;
			    	break;
			case 0x0c:
				*zHptr1 = (*zHptr1&OBEN) | 0x21;
				break;
			default:
				*zHptr1 &= OBEN;
				break;
		}
		switch(*zHptr2&(LINKSOBEN|RECHTSOBEN))
		{
			case LINKSOBEN:
			case RECHTSOBEN:
				if(FLIPCOIN)
					*zHptr2 = (*zHptr2&UNTEN) | RECHTSUNTEN;
				else	*zHptr2 = (*zHptr2&UNTEN) | LINKSUNTEN;
			    	break;
			case 0x21:
				*zHptr2 = (*zHptr2&UNTEN) | 0x0c;
				break;
			default:
				*zHptr2 &= UNTEN;
				break;
		}
/**zHptr1 = 0;
*zHptr2 = 0;*/
		*zH1 = 0;
		*zH2 = 0;
		zH1++;
		zH2++;
		zHptr1++;
		zHptr2++;
	}
	/* OK, nun die Ecken */
	zHptr1 = (TZelle *) ptrZellFeldBasis;
	zHptr1 += LinksOben;
	if(*zHptr1&RECHTSUNTEN)
		*zHptr1 = (*zHptr1 - RECHTSUNTEN) | LINKSOBEN;
	zHptr2 = zHptr1 + xd;
	if(*zHptr2&LINKSUNTEN)
		*zHptr2 = (*zHptr2 - LINKSUNTEN) | RECHTSOBEN;
	zHptr1 += (yd*wSpalten);
	if(*zHptr1&RECHTSOBEN)
		*zHptr1 = (*zHptr1 - RECHTSOBEN) | LINKSUNTEN;
	zHptr2 = zHptr1 + xd;
	if(*zHptr2&LINKSOBEN)
		*zHptr2 = (*zHptr2 - LINKSOBEN) | RECHTSUNTEN;
}

void	checkMainBarrier(void)
{
/* nur oben und unten, da die beiden anderen RAender
ohnehin zur Flussanpassung genutzt werden */
/* TODO */
int	runvar;
TZelle *zHptr1,*zHptr2;

    if((localSlaveNumber==0)||(localSlaveNumber==(slaveAnzahl-1)))
    {
	zHptr1 = (TZelle *) ptrZellFeldBasis;
        zHptr1 += wSpalten;
	zHptr2 = zHptr1 + wSpalten*(wZeilen-2);
	for(runvar=0;runvar<wSpalten;runvar++)
	{
	    if(localSlaveNumber==(slaveAnzahl-1))
	    {
		if(*zHptr2&LINKSUNTEN)
			*zHptr2 = (*zHptr2 - LINKSUNTEN) | RECHTSOBEN;
		if(*zHptr2&RECHTSUNTEN)
			*zHptr2 = (*zHptr2 - RECHTSUNTEN) | LINKSOBEN;
	    }
	    if(localSlaveNumber==0)
	    {
		if(*zHptr1&LINKSOBEN)
			*zHptr1 = (*zHptr1 - LINKSOBEN) | RECHTSUNTEN;
		if(*zHptr1&RECHTSOBEN)
			*zHptr1 = (*zHptr1 - RECHTSOBEN) | LINKSUNTEN;
	    }
		zHptr1++;
		zHptr2++;
	}
    }
}

void	checkBarriers(void)
{
TRechteck	*rHptr;
TBListe		*blHptr;

	blHptr = BListeWurzel->next;
	while(blHptr != NULL)
	{
		rHptr = blHptr->Knoten;
#ifdef CHECKBARRIER__
		checkBarrier(rHptr->LinksOben.x,rHptr->LinksOben.y,rHptr->RechtsUnten.x,rHptr->RechtsUnten.y);
#endif
		blHptr = blHptr->next;
	}
#ifdef MAINBARRIER__
	checkMainBarrier();
#endif
}

int RechtsBewegung(int anz)
{
	int rval;

	anz--;
	rval = rand() % 3;
	switch(rval)
	{
		case 0:
			if(anz)	return(0x03);
			else    return(0x01);
			break;
		case 1:
			if(anz)	return(0x05);
			else	return(0x02);
			break;
		case 2:
			if(anz)	return(0x06);
			else	return(0x04);
			break;
	}
}

int LinksBewegung(int anz)
{
	int rval;

	anz--;
	rval = rand() % 3;
	switch(rval)
	{
		case 0:
			if(anz) return(0x18);
			else	return(0x08);
			break;
		case 1:
			if(anz)	return(0x28);
			else	return(0x10);
			break;
		case 2:
			if(anz) return(0x30);
			else	return(0x20);
			break;
	}
}

TZelle	BAFeld4[15] =
{ 0x0f, 0x1e, 0x1d, 0x1b, 0x17, 0x2e, 0x2d, 0x2b, 0x27,
  0x3c, 0x3a, 0x39, 0x36, 0x35, 0x33 };
TZelle BAFeld5[6] =
{ 0x1f, 0x2f, 0x3e, 0x3d, 0x3b, 0x37 };

TZelle BewegungAnpassen(TZelle Zelle)
{
	int	val;

/* TODO: nicht Regelkonform ! */
return(Zelle);
	
	val = Dichte(&Zelle);
	switch(val)
	{
		case 4:
			return(BAFeld4[rand()%15]);
			break;
		case 5:
			return(BAFeld5[rand()%6]);
			break;
		case 6:
			return(Zelle);
			break;
	}
}

			
			



