/* Lattice - Automat: Routinen zur Darstellung auf dem Bildschirm */

#define FARBAUSGABE

#include <stdio.h>
#include <stdlib.h>
#include "p5-lat.h"
#ifdef _MSDOS_
#include <dos.h>
#endif
#ifdef _UNIX_
#include "RXlib.h"
#endif

#ifdef _UNIX_
RXDisplay       *display;
RXGC            gc;
Window          window;
int             screen;
#endif

extern TWord wZeile, wSpalten;

TByte   not_yet_initialized = 1;
TByte   *GrafikBildschirm;
TByte   *Bitmap;

int     latticeShow(void);
int     lattice2BitMap(void);
int     BitMap2Screen(void);
int     ScreenInit(void);
int     ScreenBackToText(void);

#ifdef _MSDOS_
void    setzeGrafikmodus(int);
#endif

#ifdef _UNIX_
int     lattice2screen(void);
void    latClearScreen(void);
#endif

extern
int     Dichte(TZelle *);

int     showCount = 0;

int     latticeShow(void)
{
        int res;
#ifdef _MSDOS_
        if(not_yet_initialized)
        {
                res = ScreenInit();
                if(res) return(res);
                not_yet_initialized = 0;
        }
/*Bitmap direkt auf Schirm : */
        Bitmap = GrafikBildschirm;
        res = lattice2BitMap();
/*      getch();*/
        if(res) return(res);
/*TODO : Test ! */
/*      res = BitMap2Screen();
        if(res) return(res);*/
#endif
#ifdef _UNIX_
        if(not_yet_initialized)
        {
                res = ScreenInit();
                if(res) return(res);
                not_yet_initialized = 0;
        }
        if((showCount%wBildSchritte)==0)
        {
                latClearScreen();
                lattice2screen();
        }
       /* showCount++;*/        /* f. Transputerversion */
#endif
        return(0);
}

#ifndef FARBAUSGABE
#ifdef _UNIX_
int lattice2screen (void)
{
    /*
     * TODO: Hier koennte man zwischen verschiedenen Modi unterscheiden:
     */
    TWord   runx,runy,x,y;
    TWord   rtox,rtoy;          /* run to x/y */
    TWord   rfromx,rfromy;      /* run from x/y */
    TZelle  *ptrZelle,*ptrHZelle;
    TByte   *ptrBitmap1,*ptrBitmap2,*ptrBitmap3,*ptrHBitmap;
    TByte   BitMask;
    TWord   localZeilenLaenge;
    int     anzZellen = 0, width;

    rtox   = wSpalten*2;
    rtoy   = wZeilen*3;
    rfromx = 0;
    rfromy = 0;
    /*
     * TODO: dieser ganze Vorspann koennte auch schon
     * bei der Initialisierung berechnet werden, allerdings VORSICHT!!!
     * bei Aenderungen zur Laufzeit !
     */

    ptrHZelle  = (TZelle *) ptrZellFeldBasis;
    ptrHZelle += rfromx + (wSpalten*rfromy);
    y = 0;

    width = (wSpalten*2)/8;

    ptrHBitmap = Bitmap;

    memset (Bitmap, 0, wZeilen * 3 * width);

    for(runy=rfromy;runy<rtoy;runy+=3,y+=3) {
        ptrBitmap1 = ptrHBitmap;
        ptrBitmap2 = ptrHBitmap + width;
        ptrBitmap3 = ptrHBitmap + 2*width;
        BitMask = 0x01;

        ptrZelle = ptrHZelle;
        x        = 0;

        for(runx=rfromx;runx<rtox;runx+=2,x+=2) {
            if (*ptrZelle & LINKSOBEN)
              *ptrBitmap1 |= BitMask;
            if (*ptrZelle & LINKS)
              *ptrBitmap2 |= BitMask;
            if (*ptrZelle & LINKSUNTEN)
              *ptrBitmap3 |= BitMask;

            if (!(BitMask <<= 1)) {
                BitMask = 0x01;
                ++ptrBitmap1;
                ++ptrBitmap2;
                ++ptrBitmap3;
            }

            if (*ptrZelle & RECHTSOBEN)
              *ptrBitmap1 |= BitMask;
            if (*ptrZelle & RECHTS)
              *ptrBitmap2 |= BitMask;
            if (*ptrZelle & RECHTSUNTEN)
              *ptrBitmap3 |= BitMask;

            if (!(BitMask <<= 1)) {
                BitMask = 0x01;
                ++ptrBitmap1;
                ++ptrBitmap2;
                ++ptrBitmap3;
            }
            if(*ptrZelle)
              anzZellen++;
            ptrZelle++;
        }
        ptrHZelle += wSpalten;

        ptrHBitmap += 3*width;
    }
    RXCopyBitmap (display, window, gc,
                  Bitmap, wSpalten*2, wZeilen*3,
                  0, 0, wSpalten*2, wZeilen*3,
                  0, 0);
    fprintf(stderr,"\nBild gemalt(Bitmap), flushe jetzt ! (%d)",anzZellen);
    fflush(stderr);
    RXFlush(display);
    return(0);
}

RXGCValues      gcvals;

void    latClearScreen(void)
{
    int rx,ry;
#if 0
    gcvals.foreground = RXBlackPixel (display,screen);
    RXChangeGC (display,gc,GCForeground,&gcvals);
    RXFillRectangle (display, window, gc, 0, 0, 640, 400);
    gcvals.foreground = RXWhitePixel (display,screen);
    RXChangeGC (display,gc,GCForeground,&gcvals);
#endif
}
#endif
#endif /*keine Farbausgabe */

#ifdef FARBAUSGABE
#ifdef _UNIX_

#define Number(x) (sizeof(x)/sizeof(*(x)))

u_long pixels[6];

char *cnames[] = {
    "grey90", "grey70", "grey50", "grey30", "grey10", "grey00"
};

char bittab[] = {
    0, 1, 1, 2, 1, 2, 2, 3, 
    1, 2, 2, 3, 2, 3, 3, 4, 
    1, 2, 2, 3, 2, 3, 3, 4, 
    2, 3, 3, 4, 3, 4, 4, 5, 
    1, 2, 2, 3, 2, 3, 3, 4, 
    2, 3, 3, 4, 3, 4, 4, 5, 
    2, 3, 3, 4, 3, 4, 4, 5, 
    3, 4, 4, 5, 4, 5, 5, 6, 
};

#define CountBits(x) (bittab[(x) & 0x3f])

void
AllocColors (void)
{
    int i, r;
    RXColor xcol1, xcol2;
    Colormap cmap = RXDefaultColormap (display, screen);

    for (i = 0; i < Number (cnames); ++i)
      pixels[i] = RXBlackPixel (display, screen);

    for (i = 0; i < Number (cnames); ++i) {
	r = RXAllocNamedColor (display, cmap, cnames[i], &xcol1, &xcol2);
	if (!r) {
	    printf ("cannot alloc color %d\n", i);
	    break;
	}
	pixels[i] = xcol1.pixel;
    }
}

int lattice2screen (void)
{
    /*
     * TODO: Hier koennte man zwischen verschiedenen Modi unterscheiden:
     */
    TWord   runx,runy,x,y,i;
    TWord   rtox,rtoy;	        /* run to x/y */
    TWord   rfromx,rfromy;	/* run from x/y */
    TZelle  *ptrZelle,*ptrHZelle;
    TByte   *ptrBitmap, *ptrHBitmap;
    TByte   BitMask;
    TWord   localZeilenLaenge;
    int     anzZellen = 0, width;

    RXGCValues gcval;

    gcval.function   = GXcopy;
    gcval.foreground = 0;
    gcval.background = 0;
    RXChangeGC (display, gc, GCForeground|GCBackground|GCFunction, &gcval);
    RXFillRectangle (display, window, gc, 0, 0, wSpalten, wZeilen);

    gcval.function = GXor;
    RXChangeGC (display, gc, GCFunction, &gcval);

    rtox   = wSpalten;
    rtoy   = wZeilen;
    rfromx = 0;
    rfromy = 0;

    width = wSpalten/8;

    /*
     * TODO: dieser ganze Vorspann koennte auch schon
     * bei der Initialisierung berechnet werden, allerdings VORSICHT!!!
     * bei Aenderungen zur Laufzeit !
     */

    for (i = 1; i <= 6; ++i) {
	ptrHZelle  = (TZelle *) ptrZellFeldBasis;
	ptrHZelle += rfromx + (wSpalten*rfromy);
	y = 0;

	ptrHBitmap = Bitmap;

	memset (Bitmap, 0, wZeilen * width);

	for(runy=rfromy;runy<rtoy;runy++,y++) {
	    ptrBitmap = ptrHBitmap;
	    BitMask = 0x01;

	    ptrZelle = ptrHZelle;
	    x	     = 0;

	    for(runx=rfromx;runx<rtox;runx++,x++) {
		if (CountBits (*ptrZelle) == i)
		  *ptrBitmap |= BitMask;

		if (!(BitMask <<= 1)) {
		    BitMask = 0x01;
		    ++ptrBitmap;
		}

		if(*ptrZelle)
		  anzZellen++;
		ptrZelle++;
	    }
	    ptrHZelle  += wSpalten;
	    ptrHBitmap += width;
	}
	gcval.foreground = pixels[i-1];
	RXChangeGC (display, gc, GCForeground, &gcval);
	RXCopyBitmap (display, window, gc,
		      Bitmap, wSpalten, wZeilen,
		      0, 0, wSpalten, wZeilen,
		      0, 0);
    }
    RXFlushWindow (display, window);
fprintf(stderr,"Farbausgabe OK !\n");
fflush(stderr);
    return(0);
}

RXGCValues	gcvals;

void	latClearScreen(void)
{
#if 0
    gcvals.foreground = RXBlackPixel (display,screen);
    RXChangeGC (display,gc,GCForeground,&gcvals);
    RXFillRectangle (display, window, gc, 0, 0, 640, 400);
    gcvals.foreground = RXWhitePixel (display,screen);
    RXChangeGC (display,gc,GCForeground,&gcvals);
#endif
}
#endif


int	ScreenInit(void)
{
#ifdef _UNIX_
    display = RXOpenDisplay(NULL);
    if(!display) {
	printf ("cannot open display.\n");
	exit (0);
    }
    screen = RXDefaultScreen(display);

    gc = RXCreateGC (display, RXRootWindow (display, screen),
		     GCForeground|GCBackground, &gcvals);

    window = RXCreateSimpleWindow(display,RXRootWindow(display,screen),
				  10,10,wSpalten,wZeilen,2,
				  RXBlackPixel(display,screen),
				  RXWhitePixel(display,screen));
    RXStoreName(display,window,"GasAutomat, X11 Ausgabefenster");
    /*
     * turn off automatic updating of window. Changes become not visible
     * until RXFlushWindow() is called on the window
     */
    RXUpdateMode (display, window, 0);

    AllocColors ();

    printf("\nSchirm initialisiert:\n Screen(%d)",screen);
    fflush(stdout);

    Bitmap = malloc (wSpalten/8 * wZeilen);
    if (!Bitmap) {
	printf ("cannot alloc Bitmap\n");
	exit (0);
    }
#endif
    return(0);
}


#endif /*Farbausgabe */

#ifndef FARBAUSGABE

int     ScreenInit(void)
{
    /*
     * direkt auf Schirm umleiten
     */
#ifdef _UNIX_
    display = RXOpenDisplay(NULL);
    if(!display) {
        printf ("cannot open display.\n");
        exit (0);
    }
    screen = RXDefaultScreen(display);

    gcvals.foreground = RXBlackPixel (display, screen);
    gcvals.background = RXWhitePixel (display, screen);
    gc = RXCreateGC (display, RXRootWindow (display, screen),
                     GCForeground|GCBackground, &gcvals);

    window = RXCreateSimpleWindow(display,RXRootWindow(display,screen),
                                  10,10,wSpalten*2,wZeilen*3,2,
                                  RXBlackPixel(display,screen),
                                  RXWhitePixel(display,screen));
    RXStoreName(display,window,"GasAutomat, X11 Ausgabefenster");
    printf("\nSchirm initialisiert:\n Screen(%d)",screen);
    fflush(stdout);

    Bitmap = malloc ((wSpalten*2)/8 * wZeilen*3);
    if (!Bitmap) {
        printf ("cannot alloc Bitmap\n");
        exit (0);
    }
#endif
    return(0);
}
#endif

int     ScreenBackToText(void)
{
#ifdef _UNIX_
        RXDestroyWindow(display,window);
        RXCloseDisplay(display);
#endif
        return(0);
}
 



  
 
 
