/*Lattice Gas-Automat.

Include-File mit der Deklaration der benutzten Datentypen und Strukturen.

*/

/*#define _MSDOS_               /* Ausgabe + Compilierung auf Dos-PC */
#define _UNIX_  /* entsprechend fuer UNIX - Systeme */


#define OBENRECHTS      0x01

#define RECHTS          0x02

#define UNTENRECHTS     0x04

#define UNTENLINKS      0x08

#define LINKS           0x10

#define OBENLINKS       0x20



#define LINKSUNTEN      0x08

#define LINKSOBEN       0x20

#define RECHTSUNTEN     0x04

#define RECHTSOBEN      0x01



#define OBEN            0x33

#define UNTEN           0x1e



typedef unsigned char   TByte;

typedef TByte           BYTE;
/*
typedef unsigned short  TWord;
*/
typedef unsigned int    TWord;
typedef TWord           WORD;

typedef unsigned long   TDWord;

typedef TDWord          DWORD;

/* lediglich ein paar Datentypen, die ich gerne benutze */



typedef TByte           TZelle;

/* jedes der 6 niederwertigsten Bits steht fuer eine Richtung */



typedef enum

        {

                ObenRechts  = 0,

                Rechts      = 1,

                UntenRechts = 2,

                UntenLinks  = 3,

                Links       = 4,

                ObenLinks   = 5,

                STOP        = 6         /* zwecks Schleifenabbruch */

        } TRichtung;

/* Hier werden die Richtungen definiert (im Uhrzeigersinn) */

/* Bemerkung:

In einer Zelle ergibt sich die Richtung durch:

 LVAL = (0x01 << Richtung);

*/



typedef struct

        {

                TWord   x;

                TWord   y;

        } TPVektor;



typedef struct

        {

                TWord   x;

                TWord   y;

                TByte   r;

        } TRVektor;

/* Positions- und Richtungsvektoren */



typedef struct

        {

                TPVektor        LinksOben;

                TPVektor        RechtsUnten;

        } TRechteck;

/* definiert ein Rechteck, wird fuer Barrieren benoetigt */     



typedef struct BLISTE

        {

                TRechteck       *Knoten;

                struct BLISTE   *next;

        } TBListe;

/* definiert ein Element der "Barriere-Liste" */



typedef TZelle          *TptrZellZeile;

typedef TptrZellZeile   *TptrZellFeld;

/* Hier wird die Matrix Zeilenweise definiert. */



/*Hier kommt nun der Variablenteil, bzw. die Referenz auf sie.

Definiert werden sie in LATMAIN.C*/



extern TWord    wZeilen;        /* Anzahl der Matrixzeilen */

extern TWord    wSpalten;       /* Anzahl der Matrixspalten */

extern TWord    wSeed;          /* ZufallszahlenGenerator - Initialisierung (0=time) */

extern TWord    wBarrieren;     /* Anzahl Barrieren */

extern TWord    wBildZeile;     /* Zeilennummer der ersten darszustellenden Zelle */

extern TWord    wBildSpalte;    /* Spaltennummer d. ... */

extern TWord    wBildSchritte;  /* Anzahl der Berechnungsschritte zwischen Ausgabe */

extern TWord    wMaxZeit;       /* maximale Rechenzeit */

extern TWord    wDichte;        /* Belegungsdichte der Matrix */

extern TWord    wFluss;         /* Fluss durch die Matrix */

extern TptrZellFeld    *ptrZellFeldBasis; /* Anfangsadresse der Matrix */

extern TBListe  *BListeWurzel;  /* Wurzel der Barriereliste */

extern TBListe  *BListeAktuell; /* Zeiger auf aktuelles Element */



/* folgende Variablen werden in LATINIT.C deklariert */

extern TWord    wGrenzwert;     /* bestimmt bei der Initilisierung den Schwellwert, bei dem eine Zelle belegt wird */

extern TWord    wFlussRechts;   /* Fluss nach rechts (bzw. entsprechender Schwellwert) */

extern TWord    wFlussLinks;    /* selbiges f. Fluss nach links */


/* Fehlerausbuegel-dummy */
#ifdef _UNIX_
#define getch() sleep(1)
#endif




