/*
Transputerpraktikum SS1995, Gruppe 5, Aufgabe 7: Lattice Gasautomat

Diese Datei enthaelt den Slave.
*/

#define FLUSS__
#define CALC__
#define AUSGABE__
#define DEBUGBARR__nein
#define DEBUG__nein
#define IODEBUG__nein
#define DEBUGOUT stderr
#define INFO__nein  /* gibt Infos ueber RingUpdate, Bildasugabe,
		       etc. aus */
#define _SLAVE_
#include <stdio.h>
#include <stdlib.h>
#include "PsxIO.h"
#include "slavecom.h"
/*#include "p5-lat.h"*/

extern
int latticeInit(void);
extern 
int BerechneNeueMatrixT800(void);
extern 
int FlussEinbauen(void);
extern
int InitLatCalc(void);
extern
void ReleaseLatCalc(void);
extern
void Aufraeumen(void);

extern TZelle * ptrAufFeldBasis;

TKommando locKommando;
int localSlaveNumber;
int localStartZeile;
int slaveAnzahl;

/* Variablendeklaration */
TWord           wZeilen;        /* Anzahl der Matrixzeilen */
TWord           wSpalten;       /* und -spalten */
TWord           wSeed;          /* ZufallszahlenGenerator - Initialisierung (0=time) */
TWord           wBarrieren;     /* Anzahl Barrieren */
TWord           wBildZeile;     /* Zeilennummer der ersten darzustellenden Zelle */
TWord           wBildSpalte;    /* Spaltennummer der ersten darzustellenden Zelle */
TWord           wBildSchritte;  /* Anzahl der Berechnungsschritte zwischen Ausgabe */
TWord           wMaxZeit;       /* maximale Rechenzeit */
TWord           wDichte;        /* Belegungsdichte der Matrix */
TWord           wFluss;         /* Fluss durch die Matrix */
TptrZellFeld    *ptrZellFeldBasis; /* Anfangsadresse der Matrix */
TBListe         *BListeWurzel;  /* Wurzel der Barriereliste */
TBListe         *BListeAktuell; /* Zeiger auf aktuelles Listenelement */


int     VerteilSchleife(void);  /* Dispatcher f. eingehende Tasks */
int     LeseKommandoAusRing(void);
void    Zaehlen(void);
void    InitMatrix(void);
void    LeseBarriere(void);
void    RechenSchleife(TWord);
void    KommandoWeiterleiten(void);
void    InfosAusgeben(void);
void    MyPsxRead(int,char *,int);
void    MyPsxWrite(int,char *,int);

int main(void)
{
    /* Hauptprogramm, ruft lediglich die "Verteil-Schleife" auf, wo in
    Abhaengigkeit der eingehenden Daten einzelne Tasks ausgefuehrt werden. */
    return(VerteilSchleife());
}

int VerteilSchleife(void)
{
    /* Hier werden Kommandos gelesen und ausgefuehrt. */
    int Kommando;
    int ok = 2;
/*
#ifdef CALC__
fprintf(stderr,"Berechnung an.\n");
fflush(stderr);
#endif
#ifdef FLUSS__
fprintf(stderr,"Fluss wird berechnet.\n");
fflush(stderr);
#endif
#ifdef AUSGABE__
fprintf(stderr,"Ausgabe auf RX11 ist an.\n");
fflush(stderr);
#endif
#ifndef CALC__
fprintf(stderr,"Berechnung aus.\n");
fflush(stderr);
#endif
#ifndef FLUSS__
fprintf(stderr,"Fluss wird nicht berechnet.\n");
fflush(stderr);
#endif
#ifndef AUSGABE__
fprintf(stderr,"Ausgabe auf RX11 ist aus.\n");
fflush(stderr);
#endif
*/
   while(ok==2)
   { 
    Kommando = LeseKommandoAusRing();
    switch(Kommando)
    {
/*TODO: ACHTUNG!: Diesen Teil kann man optimieren, indem man das
Kommando weiterleitet, bevor man mit ihm arbeitet. */       
        case BESCHREIBUNG:
#ifdef DEBUG__
fprintf(DEBUGOUT,"Beschreibung, PN(%d)\n",localSlaveNumber);
fflush(DEBUGOUT);
#endif
                /* MatrixBeschreibung gelesen, d.h. Feld initialisieren */
                KommandoWeiterleiten();                
                InitMatrix();
                break;
        case BARRIERE:
                /* Barriere gelesen */                
                KommandoWeiterleiten();                
                LeseBarriere();
                break;
        case RECHNE:
#ifdef DEBUG__
fprintf(DEBUGOUT,"Rechne, PN(%d)\n",localSlaveNumber);
fflush(DEBUGOUT);
#endif
		KommandoWeiterleiten();
                latticeInit();
                RechenSchleife(locKommando.Data.schritte);
                break;
        case ENDE:
#ifdef DEBUG__
fprintf(DEBUGOUT,"Beenden, PN(%d)\n",localSlaveNumber);
fflush(DEBUGOUT);
#endif
                ok = 0;
                KommandoWeiterleiten();
                break;
        case PAUSE:
                /* wird hier ignoriert */
                fprintf(stderr,"Pause auf Slave (%d)",localSlaveNumber);
                fflush(stderr);
                KommandoWeiterleiten();
                break;
        case ZAEHLE:
#ifdef DEBUG__
fprintf(DEBUGOUT,"Zaehle, PN(%d)\n",locKommando.Data.zaehler);
fflush(DEBUGOUT);
#endif        
                Zaehlen();
                break;
        case INFO:
                /* Information ausgeben */
                InfosAusgeben();
                KommandoWeiterleiten();
                break;
        case FEHLER:
#ifdef DEBUG__
fprintf(DEBUGOUT,"Fehler !!, PN(%d)\n",localSlaveNumber);
fflush(DEBUGOUT);
#endif
                KommandoWeiterleiten();
                break;
        default:
                locKommando.code = FEHLER;
                KommandoWeiterleiten();
                fprintf(stderr,"FEHLER !! auf Slave (%d), Kommando (%d)",localSlaveNumber,Kommando);
                fflush(stderr);
                ok = 1;
                break;
    }
   }
   Aufraeumen();
   fprintf(stderr,"Slave %d beendet !\n",localSlaveNumber);
   fflush(stderr);
   return(ok);
}

int LeseKommandoAusRing(void)
{
    MyPsxRead(RING_LI,(char *) &locKommando,sizeof(TKommando));
    return(locKommando.code);
}

void Zaehlen(void)
{
    localSlaveNumber = locKommando.Data.zaehler;
    locKommando.Data.zaehler++;
    MyPsxWrite(RING_RO,(char *) &locKommando,sizeof(TKommando));
}

void InitMatrix(void)
{
    slaveAnzahl = locKommando.Data.beschreibung.slaves;
    wZeilen = locKommando.Data.beschreibung.zeilen;
    wSpalten = locKommando.Data.beschreibung.spalten;
    wBarrieren = locKommando.Data.beschreibung.barrieren;
    wSeed = locKommando.Data.beschreibung.seed;
    wBildZeile = locKommando.Data.beschreibung.dispX;
    wBildSpalte = locKommando.Data.beschreibung.dispY;
    wBildSchritte = locKommando.Data.beschreibung.dispSteps;
    wMaxZeit = locKommando.Data.beschreibung.steps;
    wDichte = locKommando.Data.beschreibung.dichte;
    wFluss = locKommando.Data.beschreibung.fluss;
    /* OK, globale Daten gelesen, nun an lokale Gegebenheiten
    anpassen */
    wSeed += localSlaveNumber; /* Um Musterbildung vorzubeugen */
    wZeilen = ((wZeilen+slaveAnzahl-1)/slaveAnzahl);
    localStartZeile = wZeilen*localSlaveNumber;
    wZeilen++;
    /* Hauptbarriere setzen */
        BListeWurzel = malloc(sizeof(TBListe));
        if(BListeWurzel == NULL)
        {
                fprintf(stderr,"\nFEHLER: zu wenig Speicher ! (Wurzel)");
                fflush(stderr);
                exit(1);
        }
        BListeWurzel->Knoten = malloc(sizeof(TRechteck));
        BListeWurzel->next   = NULL;
        BListeAktuell = BListeWurzel;
        if(BListeWurzel->Knoten == NULL)
        {
                fprintf(stderr,"\nFEHLER: zu wenig Speicher ! (Wurzel->Knoten)");
                fflush(stderr);
                exit(1);
        }       
        BListeWurzel->Knoten->LinksOben.x = 0;               
        BListeWurzel->Knoten->LinksOben.y = 0;               
        BListeWurzel->Knoten->RechtsUnten.x = wSpalten;               
        BListeWurzel->Knoten->RechtsUnten.y = wZeilen;
#ifdef DEBUG__
fprintf(stderr,"Info PN(%d): %dx%d, %d Schritte, %d Slaves\n",localSlaveNumber,wZeilen,wSpalten,wMaxZeit,slaveAnzahl);
fflush(stderr);
#endif               
}

TRechteck       *erstelleBarriere(void)
{
TRechteck       *hptr;
TBListe         *hptr2;

        hptr    = malloc(sizeof(TRechteck));
        hptr2   = malloc(sizeof(TBListe));
        if((hptr == NULL) || (hptr2 == NULL))
        {
                fprintf(stderr,"\nFEHLER !: zuwenig freier Speicher (erstelleBarriere)");
                fflush(stderr);
                exit(1);
        }
        BListeAktuell->next     = hptr2;
        hptr2->next             = NULL;
        hptr2->Knoten           = hptr;
        BListeAktuell           = hptr2;
        return(hptr);
}

void LeseBarriere(void)
{
    TRechteck *hr;
    int lox,loy,rux,ruy,wz;

    lox = locKommando.Data.barriere.loX;
    loy = locKommando.Data.barriere.loY;
    rux = locKommando.Data.barriere.ruX;
    ruy = locKommando.Data.barriere.ruY;
    /* Nachschauen, ob die Barriere ueberhaupt
    im Bereich des Slaves liegt */
    loy -= localStartZeile;
    ruy -= localStartZeile;
    wz = (int) wZeilen;
    if(((loy<wz)&&(ruy>0))||(ruy==0))
    {
    	if(loy < 0)   loy = 0;  /* Spezialfall */
    	if(ruy>wz) ruy = wz;
	if((ruy-loy)<2)
	  {
	      loy--;
	      if(loy==-2)
		{
		    loy++;
		    ruy++;
		}
	      ruy++;
	      if(ruy>wz)
		{
		    ruy = wz;
		    if(loy>0) loy--;
		}
	  }
        hr = erstelleBarriere();
        hr->LinksOben.x = lox;
        hr->LinksOben.y = loy;
        hr->RechtsUnten.x = rux;
        hr->RechtsUnten.y = ruy;
#ifdef DEBUGBARR__
if(ruy==0) fprintf(stderr,"Spezialfall: ");
fprintf(stderr,"Barriere OK, PN(%d): %d-%d (%d)\n",localSlaveNumber,loy,ruy,wZeilen);
fflush(stderr);
#endif
    }
#ifdef DEBUGBARR__    
    else
    {
        fprintf(stderr,"Barriere ignoriert, PN(%d): %d-%d (%d)\n",localSlaveNumber,loy,ruy,wZeilen);
        fflush(stderr);
    }
   /* sleep(20);*/
#endif   
}

int InRingUpdate = 0;

int RingUpdate(void)
{
    /*ACHTUNG: funktioniert nur bei mind. 2 Slaves !!!! */
    TZelle *hadr,*hadr2;
    int offset;

InRingUpdate = 0;  /* 1 = Test, nur 1. Zeile */
    if(slaveAnzahl<2)
    {
        fprintf(stderr,"FEHLER: nur 1 Slave (RingUpdate)");
        fflush(stderr);
        return(1);
    }
#ifdef INFO__
fprintf(stderr,"Ring-Update, PN(%d)",localSlaveNumber);
fflush(stderr);
#endif
    offset = (wZeilen-2)*wSpalten;
    hadr = (TZelle *) ptrZellFeldBasis;
    hadr = hadr + offset;
    if(localSlaveNumber==0) /* erster Slave */
    {
#ifdef DEBUG__
fprintf(stderr,"PN(0) -> RingUpdate\n");
fflush(stderr);
#endif
        MyPsxWrite(RING_RO,(char *) hadr,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(0) hat gesendet...");
fflush(stderr);
#endif
        hadr = hadr + wSpalten;
#ifdef DEBUG__
fprintf(stderr,"PN(0) will lesen...");
fflush(stderr);
#endif
        MyPsxRead(RING_RI,(char *) hadr,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(0) hat empfangen.\n");
fflush(stderr);
#endif
    }
    if(localSlaveNumber==(slaveAnzahl-1)) /* letzter Slave */
    {
#ifdef DEBUG__
fprintf(stderr,"PN(%d) -> RingUpdate\n",slaveAnzahl-1);
fflush(stderr);
#endif    	
        MyPsxRead(RING_LI,(char *) ptrAufFeldBasis,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat empfangen...",slaveAnzahl-1);
fflush(stderr);
#endif
#ifdef DEBUG__
fprintf(stderr,"PN(%d) will schreiben...",slaveAnzahl-1);
fflush(stderr);
#endif
        MyPsxWrite(RING_LO,(char *) ptrZellFeldBasis,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat gesendet.\n",slaveAnzahl-1);
fflush(stderr);
#endif
    }
    if((localSlaveNumber>0)&&(localSlaveNumber<(slaveAnzahl-1)))
    { /* alle uebrigen Slaves */
#ifdef DEBUG__
fprintf(stderr,"PN(%d) RingUpdate\n",localSlaveNumber);
fflush(stderr);
#endif
        MyPsxRead(RING_LI,(char *) ptrAufFeldBasis,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat gelesen...",localSlaveNumber);
fflush(stderr);
#endif      
#ifdef DEBUG__
fprintf(stderr,"PN(%d) will schreiben...",localSlaveNumber);
fflush(stderr);
#endif      
        MyPsxWrite(RING_LO,(char *) ptrZellFeldBasis,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat geschrieben...",localSlaveNumber);
fflush(stderr);
#endif      
        MyPsxWrite(RING_RO,(char *) hadr,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat wieder geschrieben...",localSlaveNumber);
fflush(stderr);
#endif              
        hadr = hadr + wSpalten;
#ifdef DEBUG__
fprintf(stderr,"PN(%d) will lesen...",localSlaveNumber);
fflush(stderr);
#endif      
        MyPsxRead(RING_RI,(char *) hadr,wSpalten);
#ifdef DEBUG__
fprintf(stderr,"PN(%d) hat gelesen...",localSlaveNumber);
fflush(stderr);
#endif      
    } 
InRingUpdate = 0;
    return(0);
}


void MatrixAusgeben(void)
{
    int length;
#ifdef AUSGABE__
    length = wZeilen*wSpalten-wSpalten;
    MyPsxWrite(DIREKT_O,(char *) ptrZellFeldBasis,length);
#ifdef INFO__
fprintf(stderr,"Laenge (%d) PN(%d)\n",length,localSlaveNumber);
fflush(stderr);
#endif
#endif
#ifdef DEBUG__
fprintf(stderr,"PN(%d) an Master (Bilddaten)\n",localSlaveNumber);
fflush(stderr);
#endif
}

void RechenSchleife(TWord RSchritte)
{
    /*TODO*/
    /*ACHTUNG: evtl. bei checkBarriers (BerechneNM)
    die Hauptbarriere (MatrixRand) entfernen */
    int runvar;
    int res;

    if(slaveAnzahl > 1)
      {
	  RingUpdate();
      }
#ifdef CALC__
    res = InitLatCalc();
    if(res)
      {
	  fprintf(stderr,"PN(%d) InitLC-Fehler\n",localSlaveNumber);
	  fflush(stderr);
      }
#endif
    for(runvar=0;runvar<RSchritte;runvar++)
    {
#ifdef CALC__
        res = BerechneNeueMatrixT800();
        if(res)
        {
                /* FEHLER */
        }
#ifdef FLUSS__
        res = FlussEinbauen();
#endif
        if(res)
        {
                /* FEHLER */
        }
#endif
        if(slaveAnzahl>1)
	  {
#ifdef DEBUG__
	      if(localSlaveNumber==0)
	      {
	        fprintf(stderr,"\n\nRufe RingUpdate auf ... PN(%d)",localSlaveNumber);
		fflush(stderr);
	      }
#endif
                RingUpdate();
	    }
        if((runvar%wBildSchritte)==0)
                MatrixAusgeben();
    }
#ifdef CALC__
    ReleaseLatCalc();
#endif
}

void InfosAusgeben(void)
{
    /*TODO*/
}

void    MyPsxRead(int Kanal,char *adr,int size)
{
    int err;
    if(InRingUpdate)
      err = PsxRead(Kanal,(char *) ptrZellFeldBasis,size);
    else err = PsxRead(Kanal,adr,size);
    if(err < 0)
      {
	  fprintf(stderr,"FEHLER!!, (%d) bei PsxRead\n",errno);
	  fflush(stderr);
      }
#ifdef DEBUG__
#ifdef IODEBUG__
    else
      {
	  fprintf(stderr,"PN(%d) las von Kanal (%d)\n",localSlaveNumber,Kanal);
      }
#endif
#endif

}

void    MyPsxWrite(int Kanal,char *adr,int size)
{
    int err;
    if(InRingUpdate)
      err = PsxWrite(Kanal,(char *) ptrZellFeldBasis,size);
    else err = PsxWrite(Kanal,adr,size);
    if(err < 0)
      {
	  fprintf(stderr,"FEHLER!!, (%d) bei PsxWrite\n",errno);
	  fflush(stderr);
      }
#ifdef DEBUG__
#ifdef IODEBUG__
    else
      {
	  fprintf(stderr,"PN(%d) schrieb auf Kanal (%d)\n",localSlaveNumber,Kanal);
      }
#endif
#endif
}

void KommandoWeiterleiten(void)
{
    MyPsxWrite(RING_RO,(char *) &locKommando,sizeof(TKommando));
}





