/* Hier werden die Datentypen, Funktionen etc. definiert,
die Master und Slave zur Kommunikation nutzen */

#ifndef _P5_LAT_
#include "p5-lat.h"
#endif

/* Kommunikationsmakros gemaess "life.c" */
#ifdef _MASTER_
#define RING_RO 7            /* rechts in Ring schreiben */
#define RING_RI 6            /* rechts aus Ring lesen */
#define RING_LI 4            /* links ... */
#define RING_LO 5            /* links ... */
#define DIREKT_O(p) (9+2*(p))  /* direkt zum Slave schreiben */
#define DIREKT_I(p) (8+2*(p))  /* ... vom ... lesen */ 
#endif
#ifdef _SLAVE_
#define RING_RO 5            /* rechts in Ring schreiben */
#define RING_RI 4            /* rechts aus Ring lesen */
#define RING_LI 0            /* links ... */
#define RING_LO 1            /* links ... */
#define DIREKT_O 7             /* direkt zum Master schreiben */
#define DIREKT_I 6             /* ... vom ... lesen */ 
#endif

/* einige Kommandocodes: */
#define BESCHREIBUNG 0x01
#define BARRIERE     0x02
#define RECHNE       0x04
#define BERECHNUNG   0x04
#define RESET        0x80
#define ENDE         0x80
#define STOP         0x80
#define PAUSE        0x40
#define GIVEINFO     0x20
#define INFO         0x20
#define ZAEHLE       0x08
#define COUNT        0x08
#define FEHLER       0x10

typedef struct
{
    TWord slaves;       /* Slave-Anzahl */
    TWord zeilen;
    TWord spalten;
    TWord barrieren;
    TWord seed;
    TWord dispX;
    TWord dispY;
    TWord dispSteps;
    TWord steps;
    TWord dichte;
    TWord fluss;
} TBeschreibung;

typedef struct
{
    TWord loX;
    TWord loY;
    TWord ruX;
    TWord ruY;
} TBarriere;

typedef struct
{
    int code;
    union
    {
      TBeschreibung beschreibung;
      TBarriere     barriere;
      TWord         schritte;
      int           zaehler;
    } Data;
} TKommando;


